# Freshdesk

Freshdesk is a customer support platform that helps businesses efficiently manage and resolve customer inquiries and issues. It provides tools to streamline customer service processes across various channels, such as email, phone, chat, and social media.

Through this integration, you will configure an Apono webhook that creates new tickets in Freshdesk when user access requests are created, approved, granted, and revoked, or when requests fail.

***

### Prerequisites

<table><thead><tr><th width="234">Item</th><th>Description</th></tr></thead><tbody><tr><td><strong>Freshdesk API Token</strong></td><td><p><a href="https://support.freshdesk.com/en/support/solutions/articles/215517">Authentication credential</a> used when making requests to the Freshdesk API<br><br>Follow the steps to generate an API token:</p><ol><li>Log in to your Freshdesk account.</li><li>Click your profile picture <strong>> Profile settings</strong></li><li>Click <strong>View API key</strong>.</li></ol></td></tr><tr><td><strong>Freshdesk API URL</strong></td><td>Route for creating a ticket in your Freshdesk instance<br><br><strong>Example</strong>: <code>https://&#x3C;SUBDOMAIN>.freshdesk.com/api/v2/tickets</code></td></tr></tbody></table>

***

### Configure a webhook

Follow these steps to configure an Apono webhook:

1. On the [**Webhooks**](https://app.apono.io/webhooks) page, click **Add Webhook**. The **Add Webhook** page appears.
2. Click **Request Webhook**.
3. Enter a unique, alphanumeric, user-friendly **Request Webhook Name** for identifying this webhook.
4. Click the **Status** toggle to **Active**.
5. From the **Method** dropdown menu, select a REST method.
6. For the webhook **URL**, enter *https\://\<SUBDOMAIN>.freshdesk.com/api/v2/tickets*.\
   \
   Be sure to replace `<SUBDOMAIN>` with the Freshdesk subdomain for your account.

{% hint style="warning" %}
The webhook URL **must adhere** to the following requirements:

* Uses the HTTPS protocol
* Does **not** specify any custom ports
  {% endhint %}

7. In the **Body Template** field, construct a JSON body for the webhook payload.

```json
{
  "description": "{ "event_type": "{{ event_type }}", "event_time": "{{ event_time }}", "id": "{{ data.id }}", "friendly_id": "{{ data.friendly_id }}", "requester_id": "{{ data.requester.id }}", "requester_name": "{{ data.requester.name }}", "requester_email": "{{ data.requester.email }}", "justification": "{{ data.justification }}", "creation_date": "{{ data.creation_date }}", "access_flow_id": "{{ data.access_flow.id }}", "access_flow_name": "{{ data.access_flow.name }}", "access_bundle_id": "{{ data.access_bundle.id }}", "access_bundle_name": "{{ data.access_bundle.id }}", "access_groups_integration_name": "{{ data.access_groups.[0].integration.name }}", "access_groups_integration_type": "{{ data.access_groups.[0].integration.type }}" }",
  "subject": "apono - {{ event_type }}",
  "email": "{{ data.requester.email }}",
  "priority": 1,
  "status": 2
}
```

{% hint style="success" %}
Click **View event's payload schema** to reveal the payload schema and available data fields. You can also refer to the [Webhook Payload Schema Reference](/docs/webhook-integrations/webhook-payload-references/webhook-payload-schema-reference.md) to read the descriptions of each data field.
{% endhint %}

8. Under **Headers**, use the following **Key** and **Value** to set the header. Be sure to replace `<FRESHDESK_TOKEN>` with a [base64-encoded authentication string](https://developers.freshdesk.com/api/#authentication) (`{ base64-encoding <api_token>:X}`).

| Key             | Value                       |
| --------------- | --------------------------- |
| *Authorization* | *Basic \<FRESHDESK\_TOKEN>* |

9. From the **Triggers** dropdown menu, select **RequestCreated**.
10. Under **Filters**, define one or several filter from the listed dropdown menus.

{% hint style="info" %}
Filters empower admins to control the data transmitted via webhooks, minimizing the amount of data third-party tools receive and reducing unnecessary clutter.

**Examples**:

* Send only production requests to your admins' Slack channel.
* Trigger Okta workflows for events from specific integrations or resource types.
* Open a ticket in Jira or ServiceNow for manually approved requests.
  {% endhint %}

11. (Optional) In the **Timeout in seconds** field, enter the duration in seconds to wait before marking the request as failed.
12. (Optional) Define **Response Validators** to verify that the response from the webhook meets specified criteria:
    1. Click **+ Add**. A row of settings appears.
    2. Starting with *$.data.*, enter the **Json Path** of the JSON parameter.
    3. In the **Expected Values** field, enter a value and press the Enter key on your keyboard.
    4. Repeat step **c** to add several expected values.
    5. Repeat steps **a-d** to add multiple response validators.
13. Click **Test** to generate a test event to trigger your webhook. A **Test successful** or **Test failed** response status will appear at the bottom of the page. A successful test will send mock data to the target system.

{% hint style="success" %}
For more information about the test, click **View Invocation Data**. A panel opens revealing the request, response, and other relevant details.

Should your test fail, view these tips to [troubleshoot your webhook](/docs/webhook-integrations/troubleshoot-a-webhook.md).
{% endhint %}

14. Click **Save Webhook**.

The new webhook appears in the **Webhooks** table. Active webhooks are preceded by a green dot. Inactive webhooks are preceded by a white dot.

Apono will send a call to Freshdesk to create a new ticket when the `RequestCreated` event is triggered.


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.apono.io/docs/webhook-integrations/request-webhook/itsm/freshdesk.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
